--- WARNING: THIS IS AN AUTO-GENERATED FILE, DO NOT EDIT. PLEASE MODIFY THE ORIGINAL SOURCE IN THE 'https://github.com/istio/istio' REPO source_repo: https://github.com/istio/istio title: mixs description: Mixer is Istio's abstraction on top of infrastructure backends. generator: pkg-collateral-docs number_of_entries: 5 max_toc_level: 2 remove_toc_prefix: 'mixs ' ---

Mixer is Istio's point of integration with infrastructure backends and is the nexus for policy evaluation and telemetry reporting.

## mixs probe

Check the liveness or readiness of a locally-running server

    mixs probe [flags]

Flags | Description
--- | ---
`--interval <duration>` | Duration used for checking the target file's last modified time. (default `0s`)
`--log_as_json` | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` | Comma-separated list of scopes for which to include caller information, scopes can be any of [adapters, all, api, attributes, default, grpcAdapter, loadshedding, mcp] (default ``)
`--log_output_level <string>` | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [adapters, all, api, attributes, default, grpcAdapter, loadshedding, mcp] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [adapters, all, api, attributes, default, grpcAdapter, loadshedding, mcp] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)
`--probe-path <string>` | Path of the file for checking the availability. (default ``)

## mixs server

Starts Mixer as a server

    mixs server [flags]

Flags | Shorthand | Description
--- | --- | ---
`--adapterWorkerPoolSize <int>` |  | Max number of goroutines in the adapter worker pool (default `1024`)
`--address <string>` |  | Address to use for Mixer's gRPC API, e.g. tcp://127.0.0.1:9092 or unix:///path/to/file (default ``)
`--apiWorkerPoolSize <int>` |  | Max number of goroutines in the API worker pool (default `1024`)
`--averageLatencyThreshold <duration>` |  | Maximum average response time supported by the server. When this limit is exceeded, the server will drop traffic. (default `0s`)
`--burstSize <int>` |  | Number of requests that are permitted beyond the configured maximum for a period of time. Only valid when used with 'maxRequestsPerSecond'. (default `0`)
`--caCertFile <string>` |  | The location of the certificate file for the root certificate authority (default `/etc/certs/root-cert.pem`)
`--certFile <string>` |  | The location of the certificate file for mutual TLS (default `/etc/certs/cert-chain.pem`)
`--configDefaultNamespace <string>` |  | Namespace used to store mesh wide configuration. (default `istio-system`)
`--configStoreURL <string>` |  | URL of the config store. Use k8s://path_to_kubeconfig, fs:// for file system, or mcps://<address> for MCP/Galley. If path_to_kubeconfig is empty, in-cluster kubeconfig is used. (default ``)
`--configWaitTimeout <duration>` |  | Timeout until the initial set of configurations are received, before declaring as ready. (default `2m0s`)
`--ctrlz_address <string>` |  | The IP Address to listen on for the ControlZ introspection facility. Use '*' to indicate all addresses. (default `localhost`)
`--ctrlz_port <uint16>` |  | The IP port to use for the ControlZ introspection facility (default `9876`)
`--keyFile <string>` |  | The location of the key file for mutual TLS (default `/etc/certs/key.pem`)
`--latencyEnforcementThreshold <ratelimit>` |  | Controls the threshold, in requests per second, above which the average latency threshold will be enforced for load-shedding (default `100`)
`--latencySampleHalflife <duration>` |  | Decay rate of samples in calculation of average response latency. (default `1s`)
`--latencySamplesPerSecond <ratelimit>` |  | Controls the frequency at which the server will sample response times to calculate the average response latency. (default `1.7976931348623157e+308`)
`--livenessProbeInterval <duration>` |  | Interval of updating file for the liveness probe. (default `0s`)
`--livenessProbePath <string>` |  | Path to the file for the liveness probe. (default ``)
`--loadsheddingMode <throttlermode>` |  | When enabled, the server will log violations but will not enforce load limits. (default `disabled`)
`--log_as_json` |  | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` |  | Comma-separated list of scopes for which to include caller information, scopes can be any of [adapters, all, api, attributes, default, grpcAdapter, loadshedding, mcp] (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [adapters, all, api, attributes, default, grpcAdapter, loadshedding, mcp] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` |  | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` |  | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` |  | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` |  | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` |  | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [adapters, all, api, attributes, default, grpcAdapter, loadshedding, mcp] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` |  | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)
`--maxConcurrentStreams <uint>` |  | Maximum number of outstanding RPCs per connection (default `1024`)
`--maxMessageSize <uint>` |  | Maximum size of individual gRPC messages (default `1048576`)
`--maxRequestsPerSecond <ratelimit>` |  | Maximum requests per second supported by the server. Any requests above this limit will be dropped. (default `0`)
`--monitoringPort <uint16>` |  | HTTP port to use for Mixer self-monitoring information (default `15014`)
`--numCheckCacheEntries <int32>` |  | Max number of entries in the check result cache (default `1500000`)
`--port <uint16>` | `-p` | TCP port to use for Mixer's gRPC API, if the address option is not specified (default `9091`)
`--profile` |  | Enable profiling via web interface host:port/debug/pprof
`--readinessProbeInterval <duration>` |  | Interval of updating file for the readiness probe. (default `0s`)
`--readinessProbePath <string>` |  | Path to the file for the readiness probe. (default ``)
`--singleThreaded` |  | If true, each request to Mixer will be executed in a single go routine (useful for debugging)
`--trace_jaeger_url <string>` |  | URL of Jaeger HTTP collector (example: 'http://jaeger:14268/api/traces?format=jaeger.thrift'). (default ``)
`--trace_log_spans` |  | Whether or not to log trace spans.
`--trace_sampling_rate <float>` |  | Sampling rate for generating trace data. Must be a value in the range [0.0, 1.0]. (default `0`)
`--trace_zipkin_url <string>` |  | URL of Zipkin collector (example: 'http://zipkin:9411/api/v1/spans'). (default ``)
`--useAdapterCRDs` |  | Whether or not to allow configuration of Mixer via adapter-specific CRDs
`--useTemplateCRDs` |  | Whether or not to allow configuration of Mixer via template-specific CRDs

## mixs version

Prints out build version information

    mixs version [flags]

Flags | Shorthand | Description
--- | --- | ---
`--output <string>` | `-o` | One of 'yaml' or 'json'. (default ``)
`--short` | `-s` | Use --short=false to generate full version information

## Environment variables

These environment variables affect the behavior of the `mixs` command.

Variable Name | Type | Default Value | Description
--- | --- | --- | ---
`BYPASS_OOP_MTLS_SAN_VERIFICATION` | Boolean | `false` | Whether or not to validate SANs for out-of-process adapters auth.
`ISTIO_LANG` | String | `` | Selects the attribute expression language runtime for Mixer.
`KUBECONFIG` | String | `` | Path for a kubeconfig file.
`POD_NAMESPACE` | String | `istio-system` | Namespace for the Mixer pod (Downward API).

## Exported metrics

Metric Name | Type | Description
--- | --- | ---
`istio_build` | `LastValue` | Istio component build info
`istio_mcp_clients_total` | `LastValue` | The number of streams currently connected.
`istio_mcp_message_sizes_bytes` | `Distribution` | Size of messages received from clients.
`istio_mcp_reconnections` | `Sum` | The number of times the sink has reconnected.
`istio_mcp_recv_failures_total` | `Sum` | The number of recv failures in the source.
`istio_mcp_request_acks_total` | `Sum` | The number of request acks received by the source.
`istio_mcp_request_nacks_total` | `Sum` | The number of request nacks received by the source.
`istio_mcp_send_failures_total` | `Sum` | The number of send failures in the source.
`mixer_config_adapter_info_config_errors_total` | `LastValue` | The number of errors encountered during processing of the adapter info configuration.
`mixer_config_adapter_info_configs_total` | `LastValue` | The number of known adapters in the current config.
`mixer_config_attributes_total` | `LastValue` | The number of known attributes in the current config.
`mixer_config_handler_configs_total` | `LastValue` | The number of known handlers in the current config.
`mixer_config_handler_validation_error_total` | `LastValue` | The number of errors encountered because handler validation returned error.
`mixer_config_instance_config_errors_total` | `LastValue` | The number of errors encountered during processing of the instance configuration.
`mixer_config_instance_configs_total` | `LastValue` | The number of known instances in the current config.
`mixer_config_rule_config_errors_total` | `LastValue` | The number of errors encountered during processing of the rule configuration.
`mixer_config_rule_config_match_error_total` | `LastValue` | The number of rule conditions that was not parseable.
`mixer_config_rule_configs_total` | `LastValue` | The number of known rules in the current config.
`mixer_config_template_config_errors_total` | `LastValue` | The number of errors encountered during processing of the template configuration.
`mixer_config_template_configs_total` | `LastValue` | The number of known templates in the current config.
`mixer_config_unsatisfied_action_handler_total` | `LastValue` | The number of actions that failed due to handlers being unavailable.
`mixer_dispatcher_destinations_per_request` | `Distribution` | Number of handlers dispatched per request by Mixer
`mixer_dispatcher_destinations_per_variety_total` | `LastValue` | Number of Mixer adapter destinations by template variety type
`mixer_dispatcher_instances_per_request` | `Distribution` | Number of instances created per request by Mixer
`mixer_handler_closed_handlers_total` | `LastValue` | The number of handlers that were closed during config transition.
`mixer_handler_daemons_total` | `LastValue` | The current number of active daemon routines in a given adapter environment.
`mixer_handler_handler_build_failures_total` | `LastValue` | The number of handlers that failed creation during config transition.
`mixer_handler_handler_close_failures_total` | `LastValue` | The number of errors encountered while closing handlers during config transition.
`mixer_handler_new_handlers_total` | `LastValue` | The number of handlers that were newly created during config transition.
`mixer_handler_reused_handlers_total` | `LastValue` | The number of handlers that were re-used during config transition.
`mixer_handler_workers_total` | `LastValue` | The current number of active worker routines in a given adapter environment.
`mixer_loadshedding_predicted_cost_shed_total` | `Sum` | The total predicted cost of all requests that have been dropped.
`mixer_loadshedding_requests_throttled` | `Sum` | The number of requests that have been dropped by the loadshedder.
`mixer_runtime_dispatch_duration_seconds` | `Distribution` | Duration in seconds for adapter dispatches handled by Mixer.
`mixer_runtime_dispatches_total` | `Count` | Total number of adapter dispatches handled by Mixer.